require 'FileExt.rb'

# Simple namespace for manipulating arrays and hashes, kinda ugly but it works
# in smaller projects.
class HashExt
	
  # Saves a hash to a csv file, it will be on the format key;value if the
  # separator (sep) is ;.
  # hsh is the hash to save
  # target_file is the full path to the file to save to
  # sep is the delimiter to be used
  def HashExt.hashToCsv(hsh, target_file, sep)
    f = File.new(target_file, File::CREAT|File::TRUNC|File::RDWR)
    hsh.each{|k, v| f.write(k+sep+v+"\n")}
    f.close()
  end

  # Saves a hash or array containing arrays of length 2 in as values, the first
  # value in each sub array will be used as key and the second as value.
  # hsh is the array or hash containing the sub arrays
  # target_fiel is the full path to the file to save to
  # sep is the delimiter to be used in the csv
  def HashExt.arrToCsv(hsh, target_file, sep)
    f = File.new(target_file, File::CREAT|File::TRUNC|File::RDWR)
    hsh.each{|v| f.write(v[0]+sep+v[1]+"\n")}
    f.close()
  end	

  # Loads a csv file into a hash. First we check if the csv file exists, if it
  # does we open it and start reading line by line. If the line is not empty or
  # containing only white characters then we try to parse it into the key => values
  # of the hash.
  # csv_file is the full path to the file to open.
  # sep is the separator to use, typically ;
  def HashExt.csvToHash(csv_file, sep)
    rarr = Hash.new
    if(File.exists?(csv_file))
      File.open(csv_file) do |file|
        while line = file.gets
          if(line =~ /^[\t\s]+#/) == nil
            line.scan(/(.+)(#{sep}{1})(.+)/o){|a, b, c| rarr[a] = c}
          end
        end
      end
    end
    return rarr	
  end

  # Loads a csv file into a 2d array.
  # csv_file is the full path to the file to open.
  # sep is the separator to use, typically ;
  def HashExt.csvTo2dArr(csv_file, sep)
    rarr = Array.new
    if(File.exists?(csv_file))
      File.open(csv_file) do |file|
        while line = file.gets
          if (line =~ /^[\t\s]+#/) == nil
            rarr << line.chomp.split(sep)
          end
        end
      end
    end
    return rarr	
  end

  # Creates a hash out of two 1d arrays, one with the keys and the other one with
  # the values.
  def HashExt.arrayCombine(keys, values)
    rhsh = Hash.new
    key = " "
    while(key != nil)
      key = keys.shift
      value = values.shift
      rhsh[key] = value
    end	
    return rhsh
  end

  # Returns all matches to a regular expression in a file, it doesn't have to be
  # a php file, it can be any kind of file but it's usually a php file. The regex
  # must be of the form /()()()/.
  def HashExt.fileGetPhpTransl(php_file, regex)
    rarr = Hash.new
    str = IO.read(php_file)
    str.scan(regex){|a, b, c| rarr[b] = ""}
    return rarr
  end

  # Walks a whole directory and parses all files matching the extension which
  # defaults to 'php'. The regex must be of the form /()()()/.
  def HashExt.dirGetPhpTransl(start_folder, regex, extension = 'php')
    file_list = FileExt.getFileListR(start_folder, extension)
    rarr = Hash.new
    file_list.each{|php_file| rarr.merge!(HashExt.fileGetPhpTransl(php_file, regex))}
    return rarr
  end

  # Uses the arrow hash to shoot at the target hash, if the target doesn't have
  # the key being shot a new key with the corresponding value will be created
  # in the target hash.
  def HashExt.hashCopyValsTo(arrow, target)
    arrow.each{|ak, av| 
      if target.has_key?(ak) == false
        target[ak] = av
      end
    }
    return target
  end
  
  # Uses the arrow hash to shoot at the target hash. If the target has the key
  # being shot then that key will be overwritten. If the target doesn't have
  # the key nothing will happen.
  def HashExt.hashIntersect(arrow, target)
    arrow.each{|ak, av| if target.has_key?(ak) : target[ak] = av end }
    return target
  end
	
end





